---
title: Update a personal access token
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Key Management
---

# Update a personal access token{% #update-a-personal-access-token %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                 |
| ----------------- | ---------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/personal_access_tokens/{token_id} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/personal_access_tokens/{token_id} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/personal_access_tokens/{token_id}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/personal_access_tokens/{token_id}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/personal_access_tokens/{token_id}  |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/personal_access_tokens/{token_id}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/personal_access_tokens/{token_id} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/personal_access_tokens/{token_id} |

### Overview

Update a specific personal access token. This endpoint requires any of the following permissions:
`user_app_keys``org_app_keys_write` 


### Arguments

#### Path Parameters

| Name                       | Type   | Description                 |
| -------------------------- | ------ | --------------------------- |
| token_id [*required*] | string | The ID of the access token. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type     | Description                                                                         |
| ------------ | ---------------------------- | -------- | ----------------------------------------------------------------------------------- |
|              | data [*required*]       | object   | Object used to update an access token.                                              |
| data         | attributes [*required*] | object   | Attributes used to update an access token.                                          |
| attributes   | name                         | string   | Name of the access token.                                                           |
| attributes   | scopes                       | [string] | Array of scopes to grant the access token.                                          |
| data         | id [*required*]         | string   | ID of the access token.                                                             |
| data         | type [*required*]       | enum     | Personal access tokens resource type. Allowed enum values: `personal_access_tokens` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "personal_access_tokens",
    "id": "string",
    "attributes": {
      "name": "Example-Key-Management-updated"
    }
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response for retrieving an access token.

| Parent field  | Field                  | Type      | Description                                                                         |
| ------------- | ---------------------- | --------- | ----------------------------------------------------------------------------------- |
|               | data                   | object    | Datadog access token.                                                               |
| data          | attributes             | object    | Attributes of an access token.                                                      |
| attributes    | created_at             | date-time | Creation date of the access token.                                                  |
| attributes    | expires_at             | date-time | Expiration date of the access token.                                                |
| attributes    | last_used_at           | date-time | Date the access token was last used.                                                |
| attributes    | modified_at            | date-time | Date of last modification of the access token.                                      |
| attributes    | name                   | string    | Name of the access token.                                                           |
| attributes    | public_portion         | string    | The public portion of the access token.                                             |
| attributes    | scopes                 | [string]  | Array of scopes granted to the access token.                                        |
| data          | id                     | string    | ID of the access token.                                                             |
| data          | relationships          | object    | Resources related to the access token.                                              |
| relationships | owned_by               | object    | Relationship to user.                                                               |
| owned_by      | data [*required*] | object    | Relationship to user object.                                                        |
| data          | id [*required*]   | string    | A unique identifier that represents the user.                                       |
| data          | type [*required*] | enum      | Users resource type. Allowed enum values: `users`                                   |
| data          | type                   | enum      | Personal access tokens resource type. Allowed enum values: `personal_access_tokens` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T00:00:00+00:00",
      "expires_at": "2025-12-31T23:59:59+00:00",
      "last_used_at": "2025-06-15T12:30:00+00:00",
      "modified_at": "2024-06-01T00:00:00+00:00",
      "name": "My Access Token",
      "public_portion": "ddpat_abc123",
      "scopes": [
        "dashboards_read",
        "dashboards_write"
      ]
    },
    "id": "string",
    "relationships": {
      "owned_by": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "personal_access_tokens"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export token_id="00000000-0000-1234-0000-000000000000" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/personal_access_tokens/${token_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "name": "Updated Personal Access Token",
      "scopes": [
        "dashboards_read",
        "dashboards_write"
      ]
    },
    "id": "00112233-4455-6677-8899-aabbccddeeff",
    "type": "personal_access_tokens"
  }
}
EOF 
                        
##### 

```go
// Update a personal access token returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "personal_access_token" in the system
	PersonalAccessTokenDataID := os.Getenv("PERSONAL_ACCESS_TOKEN_DATA_ID")

	body := datadogV2.PersonalAccessTokenUpdateRequest{
		Data: datadogV2.PersonalAccessTokenUpdateData{
			Type: datadogV2.PERSONALACCESSTOKENSTYPE_PERSONAL_ACCESS_TOKENS,
			Id:   PersonalAccessTokenDataID,
			Attributes: datadogV2.PersonalAccessTokenUpdateAttributes{
				Name: datadog.PtrString("Example-Key-Management-updated"),
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewKeyManagementApi(apiClient)
	resp, r, err := api.UpdatePersonalAccessToken(ctx, PersonalAccessTokenDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `KeyManagementApi.UpdatePersonalAccessToken`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `KeyManagementApi.UpdatePersonalAccessToken`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Update a personal access token returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.KeyManagementApi;
import com.datadog.api.client.v2.model.PersonalAccessTokenResponse;
import com.datadog.api.client.v2.model.PersonalAccessTokenUpdateAttributes;
import com.datadog.api.client.v2.model.PersonalAccessTokenUpdateData;
import com.datadog.api.client.v2.model.PersonalAccessTokenUpdateRequest;
import com.datadog.api.client.v2.model.PersonalAccessTokensType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    KeyManagementApi apiInstance = new KeyManagementApi(defaultClient);

    // there is a valid "personal_access_token" in the system
    String PERSONAL_ACCESS_TOKEN_DATA_ID = System.getenv("PERSONAL_ACCESS_TOKEN_DATA_ID");

    PersonalAccessTokenUpdateRequest body =
        new PersonalAccessTokenUpdateRequest()
            .data(
                new PersonalAccessTokenUpdateData()
                    .type(PersonalAccessTokensType.PERSONAL_ACCESS_TOKENS)
                    .id(PERSONAL_ACCESS_TOKEN_DATA_ID)
                    .attributes(
                        new PersonalAccessTokenUpdateAttributes()
                            .name("Example-Key-Management-updated")));

    try {
      PersonalAccessTokenResponse result =
          apiInstance.updatePersonalAccessToken(PERSONAL_ACCESS_TOKEN_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyManagementApi#updatePersonalAccessToken");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```python
"""
Update a personal access token returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.key_management_api import KeyManagementApi
from datadog_api_client.v2.model.personal_access_token_update_attributes import PersonalAccessTokenUpdateAttributes
from datadog_api_client.v2.model.personal_access_token_update_data import PersonalAccessTokenUpdateData
from datadog_api_client.v2.model.personal_access_token_update_request import PersonalAccessTokenUpdateRequest
from datadog_api_client.v2.model.personal_access_tokens_type import PersonalAccessTokensType

# there is a valid "personal_access_token" in the system
PERSONAL_ACCESS_TOKEN_DATA_ID = environ["PERSONAL_ACCESS_TOKEN_DATA_ID"]

body = PersonalAccessTokenUpdateRequest(
    data=PersonalAccessTokenUpdateData(
        type=PersonalAccessTokensType.PERSONAL_ACCESS_TOKENS,
        id=PERSONAL_ACCESS_TOKEN_DATA_ID,
        attributes=PersonalAccessTokenUpdateAttributes(
            name="Example-Key-Management-updated",
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = KeyManagementApi(api_client)
    response = api_instance.update_personal_access_token(pat_id=PERSONAL_ACCESS_TOKEN_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Update a personal access token returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::KeyManagementAPI.new

# there is a valid "personal_access_token" in the system
PERSONAL_ACCESS_TOKEN_DATA_ID = ENV["PERSONAL_ACCESS_TOKEN_DATA_ID"]

body = DatadogAPIClient::V2::PersonalAccessTokenUpdateRequest.new({
  data: DatadogAPIClient::V2::PersonalAccessTokenUpdateData.new({
    type: DatadogAPIClient::V2::PersonalAccessTokensType::PERSONAL_ACCESS_TOKENS,
    id: PERSONAL_ACCESS_TOKEN_DATA_ID,
    attributes: DatadogAPIClient::V2::PersonalAccessTokenUpdateAttributes.new({
      name: "Example-Key-Management-updated",
    }),
  }),
})
p api_instance.update_personal_access_token(PERSONAL_ACCESS_TOKEN_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```rust
// Update a personal access token returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_key_management::KeyManagementAPI;
use datadog_api_client::datadogV2::model::PersonalAccessTokenUpdateAttributes;
use datadog_api_client::datadogV2::model::PersonalAccessTokenUpdateData;
use datadog_api_client::datadogV2::model::PersonalAccessTokenUpdateRequest;
use datadog_api_client::datadogV2::model::PersonalAccessTokensType;

#[tokio::main]
async fn main() {
    // there is a valid "personal_access_token" in the system
    let personal_access_token_data_id = std::env::var("PERSONAL_ACCESS_TOKEN_DATA_ID").unwrap();
    let body = PersonalAccessTokenUpdateRequest::new(PersonalAccessTokenUpdateData::new(
        PersonalAccessTokenUpdateAttributes::new()
            .name("Example-Key-Management-updated".to_string()),
        personal_access_token_data_id.clone(),
        PersonalAccessTokensType::PERSONAL_ACCESS_TOKENS,
    ));
    let configuration = datadog::Configuration::new();
    let api = KeyManagementAPI::with_config(configuration);
    let resp = api
        .update_personal_access_token(personal_access_token_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Update a personal access token returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.KeyManagementApi(configuration);

// there is a valid "personal_access_token" in the system
const PERSONAL_ACCESS_TOKEN_DATA_ID = process.env
  .PERSONAL_ACCESS_TOKEN_DATA_ID as string;

const params: v2.KeyManagementApiUpdatePersonalAccessTokenRequest = {
  body: {
    data: {
      type: "personal_access_tokens",
      id: PERSONAL_ACCESS_TOKEN_DATA_ID,
      attributes: {
        name: "Example-Key-Management-updated",
      },
    },
  },
  patId: PERSONAL_ACCESS_TOKEN_DATA_ID,
};

apiInstance
  .updatePersonalAccessToken(params)
  .then((data: v2.PersonalAccessTokenResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
